/*----- PROTECTED REGION ID(E621.h) ENABLED START -----*/
//=============================================================================
//
// file :        E621.h
//
// description : Include file for the E621 class
//
// project :     
//
// This file is part of Tango device class.
// 
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
// 
// $Author:  $
//
// $Revision:  $
// $Date:  $
//
// $HeadURL:  $
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#ifndef E621_H
#define E621_H

#include <tango.h>
#include <USB2Client.h>


/*----- PROTECTED REGION END -----*/	//	E621.h

#ifdef TANGO_LOG
	// cppTango after c934adea (Merge branch 'remove-cout-definition' into 'main', 2022-05-23)
	// nothing to do
#else
	// cppTango 9.3-backports and older
	#define TANGO_LOG       cout
	#define TANGO_LOG_INFO  cout2
	#define TANGO_LOG_DEBUG cout3
#endif // TANGO_LOG

/**
 *  E621 class description:
 *    
 */


namespace E621_ns
{
/*----- PROTECTED REGION ID(E621::Additional Class Declarations) ENABLED START -----*/

//	Additional Class Declarations

/*----- PROTECTED REGION END -----*/	//	E621::Additional Class Declarations

class E621 : public USB2Client_ns::USB2Client
{

/*----- PROTECTED REGION ID(E621::Data Members) ENABLED START -----*/

//	Add your own data members
	string init_error;
	// Output of the SAI? command
	string sai_output;

/*----- PROTECTED REGION END -----*/	//	E621::Data Members

//	Device property data members
public:

	bool	mandatoryNotDefined;

//	Attribute data members
public:
	Tango::DevString	*attr_Firmware_read;
	Tango::DevString	*attr_SerialNumber_read;
	Tango::DevUShort	*attr_AverageTimes_read;

//	Constructors and destructors
public:
	/**
	 * Constructs a newly device object.
	 *
	 *	@param cl	Class.
	 *	@param s 	Device Name
	 */
	E621(Tango::DeviceClass *cl,std::string &s);
	/**
	 * Constructs a newly device object.
	 *
	 *	@param cl	Class.
	 *	@param s 	Device Name
	 */
	E621(Tango::DeviceClass *cl,const char *s);
	/**
	 * Constructs a newly device object.
	 *
	 *	@param cl	Class.
	 *	@param s 	Device name
	 *	@param d	Device description.
	 */
	E621(Tango::DeviceClass *cl,const char *s,const char *d);
	/**
	 * The device object destructor.
	 */
	~E621();


//	Miscellaneous methods
public:
	/*
	 *	will be called at device destruction or at init command.
	 */
	void delete_device();
	/*
	 *	Initialize the device
	 */
	virtual void init_device();
	/*
	 *	Always executed method before execution command method.
	 */
	virtual void always_executed_hook();

	/*
	 *	Check if mandatory property has been set
	 */
	 void check_mandatory_property(Tango::DbDatum &class_prop, Tango::DbDatum &dev_prop);

//	Attribute methods
public:
	//--------------------------------------------------------
	/*
	 *	Method     : E621::read_attr_hardware()
	 *	Description: Hardware acquisition for attributes.
	 */
	//--------------------------------------------------------
	virtual void read_attr_hardware(std::vector<long> &attr_list);
	//--------------------------------------------------------
	/*
	 *	Method     : E621::write_attr_hardware()
	 *	Description: Hardware writing for attributes.
	 */
	//--------------------------------------------------------
	virtual void write_attr_hardware(std::vector<long> &attr_list);

/**
 *	Attribute Firmware related methods
 *
 *
 *	Data type:	Tango::DevString
 *	Attr type:	Scalar
 */
	virtual void read_Firmware(Tango::Attribute &attr);
	virtual bool is_Firmware_allowed(Tango::AttReqType type);
/**
 *	Attribute SerialNumber related methods
 *
 *
 *	Data type:	Tango::DevString
 *	Attr type:	Scalar
 */
	virtual void read_SerialNumber(Tango::Attribute &attr);
	virtual bool is_SerialNumber_allowed(Tango::AttReqType type);
/**
 *	Attribute AverageTimes related methods
 *
 *
 *	Data type:	Tango::DevUShort
 *	Attr type:	Scalar
 */
	virtual void read_AverageTimes(Tango::Attribute &attr);
	virtual void write_AverageTimes(Tango::WAttribute &attr);
	virtual bool is_AverageTimes_allowed(Tango::AttReqType type);

//	Dynamic attribute methods
public:

	/**
	 *	Attribute Position related methods
	 *
	 *
	 *	Data type:	Tango::DevDouble
	 *	Attr type:	Scalar
	 */
	virtual void read_Position(Tango::Attribute &attr);
	virtual void write_Position(Tango::WAttribute &attr);
	virtual bool is_Position_allowed(Tango::AttReqType type);
	void add_Position_dynamic_attribute(std::string attname);
	void remove_Position_dynamic_attribute(std::string attname);
	Tango::DevDouble *get_Position_data_ptr(std::string &name);
	std::map<std::string,Tango::DevDouble>	   Position_data;

	//--------------------------------------------------------
	/**
	 *	Method     : E621::add_dynamic_attributes()
	 *	Description: Add dynamic attributes if any.
	 */
	//--------------------------------------------------------
	void add_dynamic_attributes();




//	Command related methods
public:


	//--------------------------------------------------------
	/**
	 *	Method     : E621::add_dynamic_commands()
	 *	Description: Add dynamic commands if any.
	 */
	//--------------------------------------------------------
	void add_dynamic_commands();

/*----- PROTECTED REGION ID(E621::Additional Method prototypes) ENABLED START -----*/

//	Additional Method prototypes
	void check_init();
	void check_state();
	void verify_command_execution();
	void _command(const string &cmd);
	void command(const string &cmd);
	void _command(const string &cmd, string &rep);
	void command(const string &cmd, string &rep);

/*----- PROTECTED REGION END -----*/	//	E621::Additional Method prototypes
};

/*----- PROTECTED REGION ID(E621::Additional Classes Definitions) ENABLED START -----*/

//	Additional Classes Definitions

/*----- PROTECTED REGION END -----*/	//	E621::Additional Classes Definitions

}	//	End of namespace

#endif   //	E621_H
