/*----- PROTECTED REGION ID(E621Class.h) ENABLED START -----*/
//=============================================================================
//
// file :        E621Class.h
//
// description : Include for the E621 root class.
//               This class is the singleton class for
//                the E621 device class.
//               It contains all properties and methods which the 
//               E621 requires only once e.g. the commands.
//
// project :     
//
// This file is part of Tango device class.
// 
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
// 
// $Author:  $
//
// $Revision:  $
// $Date:  $
//
// $HeadURL:  $
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#ifndef E621Class_H
#define E621Class_H

#include <tango.h>
#include <USB2ClientClass.h>
#include <E621.h>


/*----- PROTECTED REGION END -----*/	//	E621Class.h


namespace E621_ns
{
/*----- PROTECTED REGION ID(E621Class::classes for dynamic creation) ENABLED START -----*/


/*----- PROTECTED REGION END -----*/	//	E621Class::classes for dynamic creation

//=========================================
//	Define classes for attributes
//=========================================
//	Attribute Firmware class definition
class FirmwareAttrib: public Tango::Attr
{
public:
	FirmwareAttrib():Attr("Firmware",
			Tango::DEV_STRING, Tango::READ) {}
	~FirmwareAttrib() {}
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<E621 *>(dev))->read_Firmware(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<E621 *>(dev))->is_Firmware_allowed(ty);}
};

//	Attribute SerialNumber class definition
class SerialNumberAttrib: public Tango::Attr
{
public:
	SerialNumberAttrib():Attr("SerialNumber",
			Tango::DEV_STRING, Tango::READ) {}
	~SerialNumberAttrib() {}
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<E621 *>(dev))->read_SerialNumber(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<E621 *>(dev))->is_SerialNumber_allowed(ty);}
};

//	Attribute AverageTimes class definition
class AverageTimesAttrib: public Tango::Attr
{
public:
	AverageTimesAttrib():Attr("AverageTimes",
			Tango::DEV_USHORT, Tango::READ_WRITE) {}
	~AverageTimesAttrib() {}
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<E621 *>(dev))->read_AverageTimes(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<E621 *>(dev))->write_AverageTimes(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<E621 *>(dev))->is_AverageTimes_allowed(ty);}
};


//=========================================
//	Define classes for dynamic attributes
//=========================================
//	Attribute Position class definition
class PositionAttrib: public Tango::Attr
{
public:
	PositionAttrib(const std::string &att_name):Attr(att_name.c_str(),
			Tango::DEV_DOUBLE, Tango::READ_WRITE) {}
	~PositionAttrib() {}
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<E621 *>(dev))->read_Position(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<E621 *>(dev))->write_Position(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<E621 *>(dev))->is_Position_allowed(ty);}
};


/**
 *	The E621Class singleton definition
 */

#ifdef _TG_WINDOWS_
class __declspec(dllexport)  E621Class : public USB2Client_ns::USB2ClientClass
#else
class E621Class : public USB2Client_ns::USB2ClientClass
#endif
{
	/*----- PROTECTED REGION ID(E621Class::Additional DServer data members) ENABLED START -----*/
	
	
	/*----- PROTECTED REGION END -----*/	//	E621Class::Additional DServer data members

	public:
		//	write class properties data members
		Tango::DbData	cl_prop;
		Tango::DbData	cl_def_prop;
		Tango::DbData	dev_def_prop;
		//	Method prototypes
		static E621Class *init(const char *);
		static E621Class *instance();
		~E621Class();
		Tango::DbDatum	get_class_property(std::string &);
		Tango::DbDatum	get_default_device_property(std::string &);
		Tango::DbDatum	get_default_class_property(std::string &);

	protected:
		E621Class(std::string &);
		static E621Class *_instance;
		void command_factory();
		void attribute_factory(std::vector<Tango::Attr *> &);
		void pipe_factory();
		void write_class_property();
		void set_default_property();
		void get_class_property();
		std::string get_cvstag();
		std::string get_cvsroot();

	private:
		void device_factory(TANGO_UNUSED(const Tango::DevVarStringArray *));
		void create_static_attribute_list(std::vector<Tango::Attr *> &);
		void erase_dynamic_attributes(const Tango::DevVarStringArray *,std::vector<Tango::Attr *> &);
		std::vector<std::string>	defaultAttList;
		Tango::Attr *get_attr_object_by_name(std::vector<Tango::Attr *> &att_list, std::string attname);
};

}	//	End of namespace

#endif   //	E621_H
