/*----- PROTECTED REGION ID(E621::DynAttrUtils.cpp) ENABLED START -----*/
//=============================================================================
//
// file :        E621DynAttrUtils.cpp
//
// description : Dynamic attributes utilities file for the E621 class
//
// project :     
//
// This file is part of Tango device class.
// 
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
// 
// $Author:  $
//
// $Revision:  $
// $Date:  $
//
// $HeadURL:  $
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#include <E621.h>
#include <E621Class.h>

/*----- PROTECTED REGION END -----*/	//	E621::DynAttrUtils.cpp

//================================================================
//  Attributes managed is:
//================================================================
//  Position  |  Tango::DevDouble	Scalar
//================================================================

//	For compatibility reason, this file (E621DynAttrUtils)
//	manage also the dynamic command utilities.
//================================================================
//  The following table gives the correspondence
//  between command and method names.
//
//  Command name  |  Method name
//================================================================
//================================================================

namespace E621_ns
{
//=============================================================
//	Add/Remove dynamic attribute methods
//=============================================================

//--------------------------------------------------------
/**
 *	Add a Position dynamic attribute.
 *
 *  parameter attname: attribute name to be created and added.
 */
//--------------------------------------------------------
void E621::add_Position_dynamic_attribute(std::string attname)
{
	//	Attribute : Position
	PositionAttrib	*position = new PositionAttrib(attname);
	Tango::UserDefaultAttrProp	position_prop;
	//	description	not set for Position
	//	label	not set for Position
	position_prop.set_unit("um");
	position_prop.set_standard_unit("1.0");
	position_prop.set_display_unit("um");
	//	format	not set for Position
	position_prop.set_max_value("30");
	position_prop.set_min_value("0");
	//	max_alarm	not set for Position
	//	min_alarm	not set for Position
	//	max_warning	not set for Position
	//	min_warning	not set for Position
	//	delta_t	not set for Position
	//	delta_val	not set for Position
	/*----- PROTECTED REGION ID(E621::att_Position_dynamic_attribute) ENABLED START -----*/
	
	
	/*----- PROTECTED REGION END -----*/	//	E621::att_Position_dynamic_attribute
	position->set_default_properties(position_prop);
	//	Not Polled
	position->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	Position_data.insert(make_pair(attname, 0.0));
	add_attribute(position);
}
//--------------------------------------------------------
/**
 *	remove a Position dynamic attribute.
 *
 *  parameter attname: attribute name to be removed.
 */
//--------------------------------------------------------
void E621::remove_Position_dynamic_attribute(std::string attname)
{
	remove_attribute(attname, true, Tango::Util::instance()->_UseDb);
	std::map<std::string,Tango::DevDouble>::iterator ite;
	if ((ite=Position_data.find(attname))!=Position_data.end())
	{
		/*----- PROTECTED REGION ID(E621::remove_Position_dynamic_attribute) ENABLED START -----*/
    	
    	/*----- PROTECTED REGION END -----*/	//	E621::remove_Position_dynamic_attribute
		Position_data.erase(ite);
	}
}


//============================================================
//	Tool methods to get pointer on attribute data buffer
//============================================================
//--------------------------------------------------------
/**
 *	Return a pointer on Position data.
 *
 *  parameter attname: the specified attribute name.
 */
//--------------------------------------------------------
Tango::DevDouble *E621::get_Position_data_ptr(std::string &name)
{
	std::map<std::string,Tango::DevDouble>::iterator ite;
	if ((ite=Position_data.find(name))==Position_data.end())
	{
		TangoSys_OMemStream	tms;
		tms << "Dynamic attribute " << name << " has not been created";
		Tango::Except::throw_exception(
					(const char *)"ATTRIBUTE_NOT_FOUND",
					tms.str().c_str(),
					(const char *)"E621::get_Position_data_ptr()");
	}
	return  &(ite->second);
}


//=============================================================
//	Add/Remove dynamic command methods
//=============================================================


} //	namespace
